//
// Example of using DevIL to load textures
//
// Author: Alex V. Boreskoff <alexboreskoff@mtu-net.ru>, <steps3d@narod.ru>
//

#ifdef	MACOSX
	#include	<GLUT/glut.h>
#else
	#include	<glut.h>
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	"IL/ilut.h"

unsigned	decalMap;

/////////////////////////////////////////////////////////////////////////////////

void init ()
{
	glClearColor ( 0.0, 0.0, 0.0, 1.0 );
	glEnable     ( GL_DEPTH_TEST );
	glDepthFunc  ( GL_LEQUAL );

	glHint ( GL_POLYGON_SMOOTH_HINT,         GL_NICEST );
	glHint ( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );
}

void    startOrtho ()
{
    glMatrixMode   ( GL_PROJECTION );                   // select the projection matrix
    glPushMatrix   ();                                  // store the projection matrix
    glLoadIdentity ();                                  // reset the projection matrix
                                                        // set up an ortho screen
    glOrtho        ( 0, 512, 0, 512, -1, 1 );
    glMatrixMode   ( GL_MODELVIEW );                    // select the modelview matrix
    glPushMatrix   ();                                  // store the modelview matrix
    glLoadIdentity ();                                  // reset the modelview matrix
}

void    endOrtho ()
{
    glMatrixMode ( GL_PROJECTION );                     // select the projection matrix
    glPopMatrix  ();                                    // restore the old projection matrix
    glMatrixMode ( GL_MODELVIEW );                      // select the modelview matrix
    glPopMatrix  ();                                    // restore the old projection matrix
}

void display ()
{
	glClear ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	startOrtho ();
	glEnable      ( GL_TEXTURE_2D );
	glBindTexture ( GL_TEXTURE_2D, decalMap );

	glBegin ( GL_QUADS );

	glTexCoord2f ( 0, 0 );
	glVertex2f   ( 0, 0 );

	glTexCoord2f ( 0, 1 );
	glVertex2f   ( 0, 511 );

	glTexCoord2f ( 1,   1  );
	glVertex2f   ( 511, 511 );

	glTexCoord2f ( 1, 0 );
	glVertex2f   ( 511, 0 );

	glEnd ();

	endOrtho ();

	glutSwapBuffers ();
}

void reshape ( int w, int h )
{
   glViewport     ( 0, 0, (GLsizei)w, (GLsizei)h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
}

void key ( unsigned char key, int x, int y )
{
	if ( key == 27 || key == 'q' || key == 'Q' )	//	quit requested
    	exit ( 0 );
		
	if ( key == 'p' || key == 'P' )
		ilutGLScreenie ();
}

int main ( int argc, char * argv [] )
{
								// initialize glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
	glutInitWindowSize  ( 512, 512 );


								// create window
	glutCreateWindow ( "Simple test for DevIL" );

								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
	glutKeyboardFunc ( key     );

	if ( ilGetInteger ( IL_VERSION_NUM ) < IL_VERSION )
	{
		printf ( "Incorrect devil.dll version\n" );
		
		return 1;
	}
	
	if ( ilutGetInteger ( ILUT_VERSION_NUM ) < ILUT_VERSION )
	{
		printf ( "Incorrect ilut.dll version\n" );
		
		return 1;
	}
	
	ilInit       ();
	iluInit      ();
	ilutInit     ();
	ilutRenderer ( ILUT_OPENGL );
	
	init ();

	decalMap = ilutGLLoadImage ( "../../Textures/16.jpg" );
	
    glutMainLoop ();

	return 0;
}
