//
// Test for loading a2D texture via DevIL
//
// Author: Alex V. Boreskoff <alexboreskoff@mtu-net.ru>, <steps3d@narod.ru>
//

#include	"libExt.h"
#include	"IL/ilut.h"
#include	"Vector3D.h"
#include	"Vector2D.h"
#include	"boxes.h"
#include	"DevIL-wrap.h"

#ifdef	MACOSX
	#include	<GLUT/glut.h>
#else
	#include	<glut.h>
#endif

#include	<stdio.h>
#include	<stdlib.h>

float	 angle    = 0;
float	 angle2   = 0;
unsigned texture;


void init ()
{
	glClearColor ( 0, 0, 0, 1 );
	glEnable     ( GL_DEPTH_TEST );
	glEnable     ( GL_TEXTURE_2D );

	glHint ( GL_POLYGON_SMOOTH_HINT,         GL_NICEST );
	glHint ( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );
}

void display ()
{
	glClear ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	glPushMatrix    ();
	glTranslatef    ( 1, 1, 1 );
	glRotatef       ( angle,  1, 1, 0 );
	glRotatef       ( angle2, 0, 1, 1 );

	drawBox ( Vector3D ( 0, 0, 0 ), Vector3D ( 0.5, 0.5, 0.5 ), texture );

	glPopMatrix     ();
	glutSwapBuffers ();
}

void reshape ( int w, int h )
{
   glViewport     ( 0, 0, (GLsizei)w, (GLsizei)h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   gluPerspective ( 60.0, (GLfloat)w/(GLfloat)h, 1.0, 60.0 );
   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
   gluLookAt      ( 0.0, 0.0, 0.0,		// eye
					5.0, 5.0, 5.0,		// center
					0.0, 1.0, 0.0 );
}

void key ( unsigned char key, int x, int y )
{
	if ( key == 27 || key == 'q' || key == 'Q' )		// quit requested
		exit ( 0 );
		
	if ( key == 'p' || key == 'P' )
		ilutGLScreenie ();
}

void	animate ()
{
	angle  = 0.04f * glutGet ( GLUT_ELAPSED_TIME );
	angle2 = 0.01f * glutGet ( GLUT_ELAPSED_TIME );

	glutPostRedisplay ();
}

int main ( int argc, char * argv [] )
{
								// initialize glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
	glutInitWindowSize  ( 500, 500 );


								// create window
	glutCreateWindow ( "DevIL texture2D example" );

								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
	glutKeyboardFunc ( key     );
	glutIdleFunc     ( animate );

	if ( ilGetInteger ( IL_VERSION_NUM ) < IL_VERSION )
	{
		printf ( "Incorrect devil.dll version\n" );
		
		return 1;
	}
	
	if ( ilutGetInteger ( ILUT_VERSION_NUM ) < ILUT_VERSION )
	{
		printf ( "Incorrect ilut.dll version\n" );
		
		return 1;
	}
	
	init           ();
	initExtensions ();
	
	texture = loadTexture2D ( "../../Textures/block.bmp", true );

	glutMainLoop ();

	return 0;
}
